importPackage(java.awt);
importPackage(java.awt.geom);

include(Resources.id("mtrsteamloco:scripts/display_helper.js"));

let slotCfg = {
  "version": 1,
  "texSize": [1877, 512],
  "slots": [
    {
      "name": "side",    
      "texArea": [0, 0, 1877, 128],
      "pos": [
        [[-1.1307, 1.9005, 0.6875], [-1.1932, 1.838, 0.6875], [-1.1932, 1.838, -0.6875], [-1.1307, 1.9005, -0.6875]]
      ],
      "offsets": [[0, 0, 0], [0, 0, 4], [0, 0, 8], [0, 0, -4], [0, 0, -8]]
    },
    {
      "name": "side_m",    
      "texArea": [0, 256, 1877, 128],
      "pos": [
        [[1.1307, 1.9005, -0.6875], [1.1932, 1.838, -0.6875], [1.1932, 1.838, 0.6875], [1.1307, 1.9005, 0.6875]]
      ],
      "offsets": [[0, 0, 0], [0, 0, 4], [0, 0, 8], [0, 0, -4], [0, 0, -8]]
    }
  ]
};

var serifFont = Resources.getSystemFont("Noto Sans");
var tmrtclockFont = Resources.readFont(Resources.idRelative("trtcclockbitmap.ttf"));
const maxTickDispConst = 80;
var dhBase = new DisplayHelper(slotCfg);

function displCreate(ctx, state, train) {
	state.pisRateLimit = new RateLimit(0.07);
  state.dh = dhBase.create();
  state.displTick = 0;

  state.displTickMax = 0;

  state.frontTick = 0;
  state.frontTickMax = 0;

  state.mainSITick = 0;
  state.mainSITickMax = 0;

  state.doorIndicateTick = 0;
  state.doorIndicateTickMax = 0;
}

function displDispose(ctx, state, train) {
	state.dh.close();
}

function displRender(ctx, state, train, matrices) {
	if (state.pisRateLimit.shouldUpdate()) {
    upadteTick(state, train); // systematization of ticks, needed for optimization
    let g = null;

    g = state.dh.graphics();
    let fontMetrics;
    fontMetrics = g.getFontMetrics(); 
    
    let end = state.displString2;
    let tickerclock = state.displString3;
    let end_width = Math.round(fontMetrics.stringWidth(end));
    let route_num = state.routeNum;
    let route_color = state.routecolor;
    let timetick = (MinecraftClient.worldDayTime());
    let timehour = Math.floor((timetick + 6000) * 0.001) % 24;
    let timemin = Math.floor((timetick + 6000) * (0.001 * 60)) % 60;
    let timeclockhr = "00"
    let timeclockmin = "00"
    let timeclockhrmin24 = "00:00"
    let front = 1

    if(train.isReversed()){front = train.trainCars();}else{front = 1;}

    if (timehour < 10){
      timeclockhr = "0" + timehour;
    }else{
      timeclockhr = timehour;
    }

    if (timemin < 10){
      timeclockmin = "0" + timemin;
    }else{
      timeclockmin = timemin;
    }

    timeclockhrmin24 = timeclockhr + ":" + timeclockmin;

    state.frontTickMax = Math.floor(maxTickDispConst * end_width / 500);
    state.mainSITickMax = 720; //full cycle of main passenger info display = 36 sec
    state.doorIndicateTickMax = 240; //full cycle of door indicator animation = 12 sec

    if ((state.displTickMax == 0) || (state.displTick % Math.floor(state.displTickMax / 5) == 0)) { // every maxTickDisp-th tick the variable is updated. This is necessary for optimization, so that every tick does not call functions
      
      if (train.getThisRoutePlatforms().size() != 0) {
        state.displString2 = getEndStationName(train);
        state.displString3 = timeclockhrmin24;
        state.routeNum = getRouteNum(train);
        state.routecolor = getRouteColor(train);
      } else {
        state.displString2 = "";
        state.displString3 = timeclockhrmin24;
        state.routeNum = "--";
        state.routecolor = Color.GREEN;
      }
    }
    
    if(train.isReversed()){
      drawMainSI(g, state, train, 353, 128, 128, 1172, true);
      drawMainSI(g, state, train, 353, 384, 128, 1172, false);
    }else{
      drawMainSI(g, state, train, 353, 128, 128, 1172, false);
      drawMainSI(g, state, train, 353, 384, 128, 1172, true);
    }

    if(train.doorRightOpen[front]){
      drawdoorindicate(g, state, 1525, 128); // RF
    }else{  
      drawclock(g, state, tickerclock, 1525, 128); // RB
      
    }
    if (train.getThisRoutePlatforms().size() != 0) {
      drawDestination(g, state, route_color, 0, 128, end, fontMetrics);
      //drawclock(g, state, route_color, 0, 128); // LB
    }else{
      drawclock(g, state, tickerclock, 0, 128); // RF
    }

    if(train.doorLeftOpen[front]){
      drawdoorindicate(g, state, 1525, 384); // LF
    }else{  
      
      drawclock(g, state, tickerclock, 1525, 384); // LF
    }
    if (train.getThisRoutePlatforms().size() != 0) {
      drawDestination(g, state, route_color, 0, 384, end, fontMetrics);
      //drawclock(g, state, route_color, 0, 384); // LB
    }else{
      drawclock(g, state, tickerclock, 0, 384); // LB
    }

    /*

    drawclock(g, state, tickerclock, 1525, 128); // RB
    drawclock(g, state, tickerclock, 0, 128); // RF
     
    drawclock(g, state, tickerclock, 0, 384); // LB
    drawclock(g, state, tickerclock, 1525, 384); // LF
    */

    state.dh.upload();
  }

  for (let i = 0; i < train.trainCars(); i++) {
    ctx.drawCarModel(state.dh.model, i, matrices);
  }
}

function upadteTick(state, train) {
  state.displTick ++
  if (state.displTickMax < state.displTick) state.displTick = 0;

  state.frontTick++;
  if (state.frontTickMax < state.frontTick) state.frontTick = 0;

  state.doorIndicateTick ++;
  if (state.doorIndicateTickMax < state.doorIndicateTick) state.doorIndicateTick = 0;

  state.mainSITick ++;
  if (state.mainSITickMax < state.mainSITick) state.mainSITick = 0;
} 

function getEndStation(train) {
  let stationList = train.getThisRoutePlatforms();
  let ret = "";
  ret = stationList[0].destinationName;
  return ret;
}

function getEndStationName(train) {
  let stationList = train.getThisRoutePlatforms();
  let ret = "";
  let index = (train.getThisRoutePlatformsNextIndex()) - 1;
  if((index) >= 0 && index <= train.getThisRoutePlatforms().size()){
    ret = stationList[index].destinationName;
  }else if((index) <= 0){
    ret = stationList[0].destinationName;
  }else{
    ret = ""
  }
  return ret;
}

function getNextStationName(train, offset) {
  let stationList = train.getThisRoutePlatforms();
  let ret = "";
  let index = (train.getThisRoutePlatformsNextIndex()) - 1;
  index = index + offset;
  if((index) >= 0 && index <= train.getThisRoutePlatforms().size()){
    ret = stationList[index].station.name;
  }else if((index) <= 0){
    ret = stationList[0].station.name;
  }else{
    ret = ""
  }
  return (ret + "");
}


function getStation(train){
  let stationList = train.getThisRoutePlatforms();
  let ret;
  let index = (train.getThisRoutePlatformsNextIndex()) - 1;
  if((index) >= 0 && index <= train.getThisRoutePlatforms().size()){
    ret = stationList[index].station;
  }else if((index) <= 0){
    ret = stationList[0].station;
  }else{
    ret = []
  }
  return ret;
}

function getPlatform(train){
  let stationList = train.getThisRoutePlatforms();
  let ret;
  let index = (train.getThisRoutePlatformsNextIndex());
  if((index) >= 0 && index <= train.getThisRoutePlatforms().size()){
    ret = stationList[index];
  }else if((index) <= 0){
    ret = stationList[0];
  }else{
    ret = []
  }
  return ret;
}

function convertJavaListToArray(javaListJson) {
  // Parse the JSON string to create a JavaScript array
  const javascriptArray = JSON.parse(javaListJson);
  
  return javascriptArray;
}

function getInterchangeRouteNames(train, stations, isCJK) {
  // Initialize an array to hold transfer tuples for each station
  var stationsListTransferTuples = [];
  let index = train.getThisRoutePlatformsNextIndex();

  for (let i = 0; i < stations.size(); i++) {
      // Get all routes for the current station
      var stationRoutes = MTRClientData.DATA_CACHE.stationIdToRoutes.get(
          new java.lang.Long(stations.get(i).station.id)
      );

      // Initialize an array to hold transfer tuples for the current station
      var transferTuples = [];
      
      // Find routes with different colors and store their names
      for (let colorNameTuple of stationRoutes.values()) {
          if (colorNameTuple.color !== stations[i].route.color) {
              transferTuples.push(colorNameTuple.name);
          }
      }

      // Add the transfer tuples of the current station to the main array
      stationsListTransferTuples.push(transferTuples);
  }

  if (isCJK && stationsListTransferTuples[index] + "" != "") {
    let txt = "";
      
      for (let i in stationsListTransferTuples[index]) {
          let route = stationsListTransferTuples[index][i];
          let routeCJK = getCJK(route);
          txt += routeCJK;
          
          if (i < (stationsListTransferTuples[index].length) - 1) {
              txt += "、";
          }
      }
      if(txt != ""){
        let context = "轉乘";
        context += txt;
        context += "，請在本站換車。";
        return context;
      }
  } else if(isCJK == false && stationsListTransferTuples[index] + "" != ""){
    let txt = "";
      
    for (let i in stationsListTransferTuples[index]) {
        let route = stationsListTransferTuples[index][i];
        let routeNCJK = getNCJK(route);
        txt += routeNCJK;
        
        if (i < (stationsListTransferTuples[index].length) - 1) {
            txt += ", ";
        }
    }
    if(txt != ""){
      let context = "Transfer station for the ";
      context += txt;
      context += ".";
      return context;
    }
  } else {
      return "";
  }
}

function drawclock(g, state, t_string, x, y) {
  g.setColor(Color.BLACK);
  g.fillRect(x, y-128, 352, 128);
  g.setFont(tmrtclockFont.deriveFont(0, 80));
  g.setColor(Color.GREEN);

  // print (t_string +"="+t_width)
  g.drawString(t_string, x+64, y-32);

  // state.dh.upload();
}

function drawdoorindicate(g, state, x, y) {
  let tick = state.doorIndicateTick;

  let half = Math.round(state.doorIndicateTickMax / 2);
  let max = Math.round(state.doorIndicateTickMax / 1);
  let DI_lx = tick % 60
  let DI_cx = 0
  let DI_cy = 0


  if(tick > 0 && tick < (max/4)){ // 0~60 tick
    g.setColor(Color.GREEN);
    g.fillRect(x, y-128, 352, 128);
    g.setFont(serifFont.deriveFont(Font.BOLD, 62));
    g.setColor(Color.BLACK);
  
    // print (t_string +"="+t_width)
    g.drawString("本側開門", x+64, y-32);
  
    g.setFont(serifFont.deriveFont(0, 64));
    g.setColor(Color.WHITE);
  
    g.drawString("本側開門", x+64, y-32);
  }else if(tick > (max/2) && tick < (max*0.75)){ // 120~180 tick
    g.setColor(Color.GREEN);
    g.fillRect(x, y-128, 352, 128);
    g.setFont(serifFont.deriveFont(Font.BOLD, 46));
    g.setColor(Color.BLACK);
  
    // print (t_string +"="+t_width)
    g.drawString("Exit This Side", x+16, y-32);
  
    g.setFont(serifFont.deriveFont(0, 48));
    g.setColor(Color.WHITE);
  
    g.drawString("Exit This Side", x+16, y-32);
  }else if(tick % 60 < 55 && tick % 60 > 5 ){ // door indicator animation, x-pos is hard-coded for the time being
    let arrowl = [[[1667-DI_lx],[1652-DI_lx],[1667-DI_lx],[1667-DI_lx],[1695-DI_lx],[1695-DI_lx],[1667-DI_lx]],[[y-128+73],[y-128+88],[y-128+104],[y-128+93],[y-128+93],[y-128+84],[y-128+84]]];
    let arrowr = [[[1734+DI_lx],[1749+DI_lx],[1734+DI_lx],[1734+DI_lx],[1706+DI_lx],[1706+DI_lx],[1734+DI_lx]],[[y-128+73],[y-128+88],[y-128+104],[y-128+93],[y-128+93],[y-128+84],[y-128+84]]];
    g.setColor(Color.BLACK);
    g.fillRect(x, y-128, 352, 128);
    g.setColor(Color.GREEN);
    g.fillRect(1651-DI_lx, y-128+14, 50, 100);
    g.fillRect(1701+DI_lx, y-128+14, 50, 100);
    g.setColor(Color.BLACK);
    g.fillRect(1656-DI_lx, y-128+19, 40, 40);
    g.fillRect(1706+DI_lx, y-128+19, 40, 40);
    g.setColor(Color.RED);
    g.fillPolygon(arrowl[0],arrowl[1],7);
    g.fillPolygon(arrowr[0],arrowr[1],7);
    drawCenterIndicator(g,tick,x,y);
    
  }else{
    g.setColor(Color.BLACK);
    g.fillRect(x, y-128, 352, 128);
  }
  

  // state.dh.upload();
}

function drawCenterIndicator(g,tick,x,y){
  let part = tick % 60
  let DI_cx = 1700;
  let DI_cy = 0;
  function arrow1(g,DI_cx,DI_cy){
    let ar = [[[DI_cx],[DI_cx-20],[DI_cx-10],[DI_cx],[DI_cx+10],[DI_cx+20]],[[DI_cy],[DI_cy+17],[DI_cy+25],[DI_cy+17],[DI_cy+25],[DI_cy+17]]];
    g.fillPolygon(ar[0],ar[1],6)
  } 
  function arrow2(g,DI_cx,DI_cy){
    let ar = [[[DI_cx],[DI_cx-26],[DI_cx-16],[DI_cx],[DI_cx+16],[DI_cx+26]],[[DI_cy],[DI_cy+17],[DI_cy+25],[DI_cy+17],[DI_cy+25],[DI_cy+17]]];
    g.fillPolygon(ar[0],ar[1],6)
  } 
  function arrow3(g,DI_cx,DI_cy){
    let ar = [[[DI_cx],[DI_cx-31],[DI_cx-21],[DI_cx],[DI_cx+21],[DI_cx+31]],[[DI_cy],[DI_cy+17],[DI_cy+25],[DI_cy+17],[DI_cy+25],[DI_cy+17]]];
    g.fillPolygon(ar[0],ar[1],6)
  } 
  g.setColor(Color.RED);
  switch (true){
    case (part>=22 && part<32):
      arrow1(g,1700,y-128+89);
      break;
    case (part>=32 && part<42):
      arrow1(g,1700,y-128+65);
      arrow2(g,1700,y-128+89);
      break;
    case (part>=42 && part<55):
      arrow1(g,1700,y-128+43);
      arrow2(g,1700,y-128+65);
      arrow3(g,1700,y-128+89);
      break;
    default:
      break;
  }
  
  
}

function drawDestination(g, state, route_color, x, y, end, fontMetrics) {
  g.setColor(Color.BLACK);
  g.fillRect(x, y-128, 353, 128);
  if(route_color){route_color}else{route_color = (Color.BLACK)};
  g.setColor(Color(route_color))
  g.fillRect(x, y-128+12, 338, 103);
  g.setColor(Color.BLACK);
  g.fillRect(x+10, y-128+22, 318, 83);
  
  let part = state.doorIndicateTick % 60

  if (part>30){ 
    g.setColor(Color(route_color));
    if(getCJK(end) != ""){
      drawStringInBox(g, getCJK(end), 1, 318, 83, x+10, y-128+22, serifFont, 0.75);
    }else{
      drawStringInBox(g, getNCJK(end), 1, 318, 83, x+10, y-128+22, serifFont, 0.6);
    }
  }else{
    g.setColor(Color(route_color));
    if(getNCJK(end) != ""){
      drawStringInBox(g, getNCJK(end), 1, 318, 83, x+10, y-128+22, serifFont, 0.6);
    }else{
      drawStringInBox(g, getCJK(end), 1, 318, 83, x+10, y-128+22, serifFont, 0.75);
    }
  }
  
}

function drawCJKinBox(g, state, route_color, x, y, end, width, height, delayTick, continueTick, approach) {
  let tick = state.mainSITick;
  let max = state.mainSITickMax;
  let scrollSpd = 5;
  let dy = (height)-((tick-delayTick)/continueTick*height*scrollSpd);
  let flash = 0;

  if(approach == true){
    flash = tick % 18;
  }else{
    flash = 0;
  }

  if(tick >= ((continueTick / scrollSpd) + delayTick)){
    dy = 0;
  }

  g.setColor(Color.BLACK);
  g.fillRect(x, y-128, width, height);
  if(flash >= 0 && flash < max/80){g.setColor(Color(route_color))};
  if(getCJK(end) != ""){
    drawStringInBox(g, getCJK(end), 1, width, height, x+10, y-128+22+dy, serifFont, 0.75);
  }else{
    drawStringInBox(g, getNCJK(end), 1, width, height, x+10, y-128+22+dy, serifFont, 0.6);
  }

  

}

function drawMainSI(g, state, train, x, y, height, width, dir){

  //let width 1~3
  let width1 = width/6;
  let width2 = width/6;
  let width3 = width/6;
  let x1 = x+(width/6)-(width1/2);
  let x2 = x+(width/6)+(width/3)-(width1/2);
  let x3 = x+(width/6)+(2*width/3)-(width1/2);
  let xa = x+(width/3)-(width1/2);
  let xb = xa + (width/3);
  let x2l = x2;

  //let end;
  let endCJK = "";
  let endNCJK = "";

  let prevStopCJK = "";
  let nextStopCJK = "";
  let thisStopCJK = "";

  let arrowCJK = "";
  let arrowCJK2 = "";
  let dirCJK = "";
  let dirCJK2 = "";
  
  //let toNextStop;
  let toNextStopCJK = "";
  let toNextStopNCJKID = "";

  //let arrThisStop;
  let arrThisStopCJK = "";
  let arrThisStopNCJKID = "";
  
  //let transfers;
  let transfersCJK = "";
  let transfersNCJK = ""; 

  //cjk direction switch
  if(dir){
    dirCJK = "→";
    dirCJK2 = "→→";
    x2l = x2;
  }else{
    dirCJK = "←";
    dirCJK2 = "←←";
    x1 = x+(width/6)+(2*width/3)-(width1/2);
    x3 = x+(width/6)-(width1/2);
    xb = x+(width/3)-(width1/2);
    xa = xb+(width/3);
    x2l = x3;
  }

  let approach = true;
  let platform = getPlatform(train);
  if(platform){
    if (platform.distance - train.railProgress() < 80){approach = true}else{approach = false};
  }
  
  let flashing = approach;

  let flash = 0;  
  if(approach !== true){
    flash = state.mainSITick % 18;
  }else{
    flash = 0;
  }
  if(flash >= 0 && flash < state.mainSITickMax/80){
    arrowCJK = dirCJK;
  }else{
    arrowCJK = "";
  }

  g.setFont(serifFont.deriveFont(0, 60));

  let stationList = train.getThisRoutePlatforms();
  //let route = stationList[0].route;
  let station = "";
  station = train.getThisRoutePlatforms();

  if(train.getThisRoutePlatforms().size() > 0 && train.getThisRoutePlatformsNextIndex() !== null){
  toNextStopNCJKID = "Next : " + getNCJK(getNextStationName(train,1)) + " " + getExtra(getNextStationName(train,1));

  arrThisStopCJK = "";
  arrThisStopCJK = "抵達：" + getCJK(getNextStationName(train,1));
  arrThisStopNCJKID = getNCJK(getNextStationName(train,1)) + " " + getExtra(getNextStationName(train,1));

  if(getNextStationName(train,1) == getEndStationName(train) && train.getThisRoutePlatformsNextIndex() !== 0){ //Next is terminus
    prevStopCJK = (getNextStationName(train,0));
    thisStopCJK = (getNextStationName(train,1));
    width2 = 1*width/2;
    x2 = x2l;
    width3 = 0
    nextStopCJK = "";
    thisStopCJK += "（終點站）";
    arrowCJK2 = "";
  }else if(train.getThisRoutePlatforms().size() - 1 <= train.getThisRoutePlatformsNextIndex() && train.getThisRoutePlatformsNextIndex() !== 0){//Next is not Terminus but no more station data
    prevStopCJK = (getNextStationName(train,0));
    thisStopCJK = (getNextStationName(train,1));
    width2 = 1*width/2;
    x2 = x2l;
    width3 = 0
    nextStopCJK = "";
    arrowCJK2 = "";
  }else if(train.getThisRoutePlatforms().size() - 1 <= 1 && train.getThisRoutePlatformsNextIndex() == 0){
    flashing = !flashing
    width2 = 1*width/2;
    x2 = x2l;
    width3 = 0
    nextStopCJK = "";
    prevStopCJK = (getNextStationName(train,1));
    thisStopCJK = (getNextStationName(train,2));
    thisStopCJK += "（終點站）";
    arrowCJK2 = dirCJK2;
  }else if(train.getThisRoutePlatforms().size() - 1 >= 2 && train.getThisRoutePlatformsNextIndex() == 0){//Arrive at the first station
    flashing = !flashing
    width2 = width/6
    prevStopCJK = (getNextStationName(train,1));
    nextStopCJK = (getNextStationName(train,3));
    thisStopCJK = (getNextStationName(train,2));
    arrowCJK2 = dirCJK2;
  }else if(train.getThisRoutePlatforms().size() - 1 >= 2){
    width2 = width/6
    prevStopCJK = (getNextStationName(train,0));
    thisStopCJK = (getNextStationName(train,1));
    nextStopCJK = (getNextStationName(train,2));
    arrowCJK2 = dirCJK2;
  }else{
    width2 = width/6
    prevStopCJK = "";
    thisStopCJK = "";
    nextStopCJK = "";
    arrowCJK2 = dirCJK2;
  }

  if((getCJK(getEndStationName(train))+"") !== ""){
    endCJK += "終點："
    endCJK += getCJK(getEndStationName(train))
  }
  
  if((getNCJK(getEndStationName(train))+"") !== ""){
    endNCJK += "To : "
    endNCJK += getNCJK(getEndStationName(train)) + " " + getExtra(getEndStationName(train)); 
  }

  }else{
    dirCJK = "";
    dirCJK2 = "";
  }


  //let serifFont = Resources.getSystemFont("Noto Sans");

  if(station != null){
    if(transfersCJK+"" != ""){
      transfersCJK = getInterchangeRouteNames(train, station, true);
    transfersCJK = transfersCJK + "";
    }
    if(transfersNCJK+"" != ""){
    transfersNCJK = getInterchangeRouteNames(train, station, false);
    transfersNCJK = transfersNCJK + "";
    }
  }
  
  if(transfersCJK == ""){transfersCJK = arrThisStopCJK};
  if(transfersNCJK == ""){transfersNCJK = arrThisStopNCJKID};
  //let color = Color.decode("#AB7F32")
  let txtcolor = Color.decode("#AB7F32")

  let tick = state.mainSITick;
  switch(true){
    case (tick < 120 && tick > 0 && !approach):
      drawTickVertical(g, state, endCJK, x, y, height, width, 1, serifFont, 0, 120, 1, txtcolor);
      break;
    case (tick < 240 && tick > 120 && !approach):
      drawTickVertical(g, state, endNCJK, x, y, height, width, 1, serifFont, 120, 120, 1, txtcolor);
      break;
    case (tick < 480 && tick > 240 && !approach):
      g.setColor(Color.BLACK);
      g.fillRect(x, y-128, width, height);
      if(nextStopCJK !== ""){drawTickVertical(g, state, arrowCJK2, xb, y, height, width/5, 1, serifFont, 240, 240, 0, (Color.GREEN))};
      drawTickVertical(g, state, arrowCJK, xa, y, height, width/5, 1, serifFont, 240, 240, 0, (Color.GREEN));
      drawCJKinBox(g, state, txtcolor, x1, y, prevStopCJK, width1, height*2/3, 240, 240, false);
      drawCJKinBox(g, state, txtcolor, x2, y, thisStopCJK, width2, height*2/3, 240, 240, false);
      drawCJKinBox(g, state, txtcolor, x3, y, nextStopCJK, width3, height*2/3, 240, 240, false);
      
      break;
    case (tick < 720 && tick > 480 && !approach):
      drawTickVertical(g, state, toNextStopNCJKID, x, y, height, width, 1, serifFont, 480, 240, 1, txtcolor);
      break;
    case (tick < 240 && tick > 0 && approach):
      g.setColor(Color.BLACK);
      g.fillRect(x, y-128, width, height);
      if(nextStopCJK !== ""){drawTickVertical(g, state, arrowCJK2, xb, y, height, width/5, 1, serifFont, 0, 240, 0, (Color.GREEN))};
      drawTickVertical(g, state, arrowCJK, xa, y, height, width/5, 1, serifFont, 0, 240, 0, (Color.GREEN));
      drawCJKinBox(g, state, txtcolor, x1, y, prevStopCJK, width1, height*2/3, 0, 240, !flashing);
      drawCJKinBox(g, state, txtcolor, x2, y, thisStopCJK, width2, height*2/3, 0, 240, flashing);
      drawCJKinBox(g, state, txtcolor, x3, y, nextStopCJK, width3, height*2/3, 0, 240, false);
      
      break;
    case (tick < 360 && tick > 240 && approach):
      drawTickVertical(g, state, arrThisStopNCJKID, x, y, height, width, 1, serifFont, 240, 120, 1, txtcolor);
      break;
    case (tick < 480 && tick > 360 && approach && (transfersCJK !== arrThisStopCJK)):
      drawTickHorizontal(g, state, transfersCJK, x, y, height, width, 1, serifFont, 360, 120, 1, txtcolor);
      break;
    case (tick < 720 && tick > 480 && approach && (transfersCJK !== arrThisStopCJK)):
      drawTickHorizontal(g, state, transfersNCJK, x, y, height, width, 1, serifFont, 480, 240, 1, txtcolor);
      break;
    case (tick < 480 && tick > 360 && approach && (transfersCJK == arrThisStopCJK)):
      drawTickVertical(g, state, transfersCJK, x, y, height, width, 1, serifFont, 360, 120, 1, txtcolor);
      break;
    case (tick < 720 && tick > 480 && approach && (transfersNCJK == arrThisStopNCJKID)):
      drawTickVertical(g, state, transfersNCJK, x, y, height, width, 1, serifFont, 480, 240, 1, txtcolor);
      break;
  }
      
}

//always scroll from bottom, scroll horizontally if string is too long.(can disable by value scrollIfToolong = 0)
function drawTickVertical(g, state, str, x, y, height, width, aligned, font, delayTick, continueTick, scrollIfToolong, color) { 
  let tick = state.mainSITick;
  let fontWidth = 0;
  let scrollSpd = 5;
  let ax = 0;
  let bx = 0;
  y = y - 128;
  if(tick <=((delayTick / scrollSpd) + delayTick) + continueTick || tick >= ((delayTick / scrollSpd) + delayTick)){
    g.setColor(Color.BLACK);
    g.fillRect(x, y, width, height);
    g.setColor(color);
    g.setFont(font.deriveFont(0, 60));
  }
  y = y + 128 - 32;


  fontMetrics = g.getFontMetrics();
  fontWidth = Math.round(fontMetrics.stringWidth(str));

    if(fontWidth >= width){
      ax = (tick-delayTick-(continueTick/scrollSpd)-continueTick*(1-1/scrollSpd)/2)/(continueTick*(1-1/scrollSpd)/2)*(width-2*fontWidth)/(1-(1/scrollSpd))
      bx = (width-fontWidth)
      aligned = 0
    }else{
    }
  
  let alignx = 0;
  alignx = isAligned(aligned, width, fontWidth);
  

  if((tick >=((continueTick / scrollSpd) + delayTick) + continueTick*(1-1/scrollSpd)/2 + (fontWidth-width)/(scrollSpd*50)) && scrollIfToolong == 1){
    g.drawString(str + "", x+alignx+bx, y);
  }else if((tick >=((continueTick / scrollSpd) + delayTick) + continueTick*(1-1/scrollSpd)/2) && scrollIfToolong == 1){
    g.drawString(str + "", x+alignx+ax, y);
  }else if(tick >= ((continueTick / scrollSpd) + delayTick)){
    g.drawString(str + "", x+alignx, y);
  }else if(tick <=((continueTick / scrollSpd) + delayTick) + continueTick){
    g.drawString(str + "", x+alignx, y+(height)-((tick-delayTick)/continueTick*height*scrollSpd));
  }
}

//appear from right and stops at the end of string, speed depends on the length of string and continueTick number.
function drawTickHorizontal(g, state, str, x, y, height, width, aligned, font, delayTick, continueTick, scrollIfToolong, color) { 
  let tick = state.mainSITick;
  let fontWidth = 0;
  let scrollSpd = 5;
  let ax = 0;
  let bx = 0;
  y = y - 128;
  if(tick <=((delayTick / scrollSpd) + delayTick) + continueTick || tick >= ((delayTick / scrollSpd) + delayTick)){
    g.setColor(Color.BLACK);
    g.fillRect(x, y, width, height);
    g.setColor(color);
    g.setFont(font.deriveFont(0, 60));
  }
  y = y + 128 - 32;


  fontMetrics = g.getFontMetrics();
  fontWidth = Math.round(fontMetrics.stringWidth(str));

      ax = (tick-delayTick-(continueTick/scrollSpd)-continueTick*(1-1/scrollSpd)/2)/(continueTick*(1-1/scrollSpd)/2)*(width-2*fontWidth)/(1-(1/scrollSpd))
      aligned = 0
      if((width-fontWidth)<=0){
        bx = (width-fontWidth);
      }else{
        bx = (0);
      }
  
  let alignx = 0;
  alignx = isAligned(aligned, width, fontWidth);
  

  if(tick >=((continueTick / scrollSpd) + delayTick) + continueTick*(1-1/scrollSpd)/2 + (-bx)/(scrollSpd*10)){
    g.drawString(str + "", x+alignx+bx, y);
  }else if(tick >=((continueTick / scrollSpd) + delayTick) + continueTick*(1-1/scrollSpd)/2){
    g.drawString(str + "", x+alignx+ax, y);
  }else if(tick >= ((continueTick / scrollSpd) + delayTick)){
    g.drawString(str + "", x+alignx+ax, y);
  }else if(tick <=((continueTick / scrollSpd) + delayTick) + continueTick){
    g.drawString(str + "", x+alignx+ax, y);
  }
}

function clamp(num, min, max) {
  return Math.min(Math.max(num, min), max);
} 

function getRouteNum(train) {
  let stationList = train.getThisRoutePlatforms();
  let ret = stationList[0].route.lightRailRouteNumber + "";
  return ret;
}

function getRoute(train) {
  let stationList = train.getThisRoutePlatforms();
  let route = stationList[0].route;
  let thisRoute = route;
  let nextRoute = route;
  let ret = [];
  ret = [thisRoute, nextRoute];
  return ret;
}

function getRouteColor(train) {
  
  let stationList = train.getThisRoutePlatforms();
  let ret = stationList[0].route.color;
  return ret;
}

function getCJK(str) {
  let cjk_str = str + "";
  cjk_str = TextUtil.getCjkParts(str)
  return cjk_str;
}

function getNCJK(str) {
  let ncjk_str = str + "";
  ncjk_str = TextUtil.getNonCjkParts(str)
  return ncjk_str;
}

function getExtra(str) {
  let extra_str = str + "";
  extra_str = TextUtil.getExtraParts(str)
  return extra_str;
}

function splitEqual(str, length) {
  if (length <= 0) return [];
  let regex = new RegExp(`.{1,${length}}`, 'g');
  return str.match(regex);
}

function drawStringInBox(g, str, aligned, boxwidth, boxheight, x, y, font, zoom) { 
  
  let fontHeight = Math.round(boxheight * zoom);
  let strwidth = 0;
  let sectionCount = 0;
  let str_sec = [];
  let countingwidth = 0;
  let fontMetrics = g.getFontMetrics();
  let partedstr = [];

  g.setFont(font.deriveFont(0, fontHeight));
  fontMetrics = g.getFontMetrics();

  strwidth = Math.round(fontMetrics.stringWidth(str));
  // sectionCount = Math.ceil(strwidth/boxwidth);

  //splitting and joining words into parts
  str_sec = str.split(" ");
  



  for (let j = 0; j < str_sec.length; j++) {
    strwidth = Math.round(fontMetrics.stringWidth(str_sec[j]));
    countingwidth = Math.round(fontMetrics.stringWidth(partedstr[partedstr.length - 1]+str_sec[j]));

    if(j > 0 && strwidth <= boxwidth){ //join into last part
      if (countingwidth <= boxwidth){
        partedstr[partedstr.length - 1] = partedstr[partedstr.length - 1] + " " + str_sec[j];
      }else{ //make new part
        partedstr.push(str_sec[j]);
      }
    }else if(strwidth > boxwidth && j > 0){ //break string into equal parts, add them to list
      let sectionCount = 1;
      let partscount = 1;
      let str = str_sec[j]+"";
      let length = str.length;
      sectionCount = (Math.floor(strwidth / boxwidth))+1;
      partscount = (Math.floor(length / 2))+1;
      let newparts = splitEqual(str_sec[j], partscount);
      partedstr = partedstr.concat(newparts);
    }else if(strwidth > boxwidth && j == 0){
      let sectionCount = 1;
      let partscount = 1;
      let str = str_sec[j]+"";
      let length = str.length;
      sectionCount = (Math.floor(strwidth / boxwidth))+1;
      partscount = (Math.floor(length / 2))+1;
      let newparts = splitEqual(str_sec[j], partscount);
      partedstr = newparts;
    }else{
      partedstr[0] = str_sec[0];
    }
  }


  //stacking parts

  fontHeight = Math.round((boxheight * zoom) / partedstr.length);
  g.setFont(font.deriveFont(0, fontHeight));
  fontMetrics = g.getFontMetrics();

  for (let i = 0; i < partedstr.length; i++) {
    
    let secwidth = fontMetrics.stringWidth(partedstr[i]);
    let sec_y = boxheight / partedstr.length * (i+1) - fontHeight * 0.2;
    
    alignx = isAligned(aligned, boxwidth, secwidth)
    
    g.drawString(partedstr[i], (alignx+x), (y+sec_y));
  }
}

function isAligned(aligned, boxwidth, secwidth){
  let alignx;

  switch(aligned){
    case 0: 
    alignx = 0; 
    break;

    case 1: 
    alignx = Math.floor((boxwidth - secwidth)/2); 
    break;

    case 2: 
    alignx = (boxwidth - secwidth); 
    break;

    default: 
    alignx = 0; 
    break;
  }
  return alignx;
}