/*MTR-NTE標準スクリプト v1.1
  作者:PIPOsen
  二次配布・商用利用を許可する※クレジット表記必須
*/
/* 基本設定 */
var modelPath = "mtr:tmrt/"; //読み込むモデルのパス（フォルダまで指定）
var usingModel = ["tmrt.obj", "tmrt2.obj"]; //読み込むモデルを記述※号車設定は別！！
var destList = ["", "品川", "大崎", "池袋", "赤羽"]; //行き先を記述
var typeList = ["", "回送", "各駅停車", "快速", "試運転"]; //種別を記述
var renderTypeLightsList = ["light", "light1"], //Lightsパーツを記述
	renderTypeAlwaysOnLightsList = [], //AlwaysOnLightsパーツを記述
	renderTypeExteriorList = ["ext","front","equipment","doorLF","doorLB","doorRF","doorRB"], //通常パーツを記述
	renderTypeInteriorList = ["i", "i_equipment", "i_seat", "light", "light1","doorLF_i","doorLB_i","doorRF_i","doorRB_i"], //発光パーツを記述
	renderTypeInteriorTranslucentList = []; //半透明パーツを記述
var idTexConnector = Resources.id("mtr:gangway/gangway_connector_exterior.png")
var idDoorOpeningSound = Resources.id("mtr:tmrt/door_open.ogg")
var idDoorClosingSound = Resources.id("mtr:tmrt/door_close.ogg")
/* パーツ登録処理 */
var registerModels = function(model){
	var result = {};
	for(var it = model.entrySet().iterator(); it.hasNext();){
		entry = it.next();
		var jsStringKey = ""+entry.getKey();
		if(renderTypeLightsList.includes(jsStringKey)){
			entry.getValue().setAllRenderType("light");
		}else{
			if(renderTypeAlwaysOnLightsList.includes(jsStringKey)){
				entry.getValue().setAllRenderType("always_on_lights");
			}else{
				if(renderTypeExteriorList.includes(jsStringKey)){
					entry.getValue().setAllRenderType("exterior");
				}else{
					if(renderTypeInteriorList.includes(jsStringKey)){
						entry.getValue().setAllRenderType("interior");
					}else{
						entry.getValue().setAllRenderType("interior_translucent");
					}
				}
			}
		}
		entry.getValue().applyUVMirror(false, false);
		result[jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
	}
	return result;
}
var modelList = [];
for(i = 0; i < usingModel.length; i++){
	modelList[i] = registerModels(ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative(modelPath+usingModel[i]), null));
}
/* 開始処理 */
function createTrain(ctx, state, train){
		/* 諸情報設定 */
		state.models = [];
		switch(train.trainCars()){ //ここで号車設定をします。両数とその時の号車ごとに使用するモデルを設定。
			case 2: //2両のとき
				state.models[0] = modelList[0]; //"tmrt.obj"
				state.models[1] = modelList[1]; //"tmrt2.obj"
				state.dirList = [0, 1]; //1にするとひっくり返る。長さ2に合わせる！
				state.controlCarList = [1, 1]; //運転台付き車両は1にする。長さ2に合わせる！
				break;
			case 3:
				state.models[0] = modelList[0];
				state.models[1] = modelList[1];
				state.models[2] = modelList[1];
				state.dirList = [0, 0, 1];
				state.controlCarList = [1, 0, 1];
				break;
			case 4:
				state.models[0] = modelList[0];
				state.models[1] = modelList[1];
				state.models[2] = modelList[0];
				state.models[3] = modelList[1];
				state.dirList = [0, 0, 1, 1];
				state.controlCarList = [1, 0, 0, 1];
				break;
			default : //6を想定
				state.models[0] = modelList[0];
				state.models[1] = modelList[1];
				state.models[2] = modelList[0];
				state.models[3] = modelList[1];
				state.models[4] = modelList[0];
				state.models[5] = modelList[1];
				state.dirList = [0, 0, 0, 1, 1, 1];
				state.controlCarList = [1, 0, 0, 0, 0, 1];
		}
};
/* 描画処理 */
function renderTrain(ctx, state, train){
	/* 諸情報取得 */
	var doorMoveValue = 0.7; //ドアの動く量
	var getDestination = function(train){
		var stationList = train.getThisRoutePlatforms();
		var ret = "";
		try{var ret = stationList.get(Math.min(train.getThisRoutePlatformsNextIndex()-1, stationList.size() - 1)).destinationName;
			return ret;}catch(e){
			return " 回送";
		}
	}
	var type = getDestination(train).split("|")[0].split(" ")[0];
	var dest = getDestination(train).split("|")[0].split(" ")[1];
	/* 描画を司る関数 */
	var render = function(part, cars){
		if(!state.models[cars][part]) return;
		matrices.pushPose();
		matrices.rotateY(state.dirList[cars]*Math.PI);
		ctx.drawCarModel(state.models[cars][part], cars, matrices);
		matrices.popPose();
	}
    var renderdetail = function(part, cars){
		if(!state.models[cars][part]) return;
		matrices.pushPose();
        if(train.shouldRenderDetail()){
            matrices.rotateY(state.dirList[cars]*Math.PI);
            ctx.drawCarModel(state.models[cars][part], cars, matrices);
        }
		matrices.popPose();
	}
	matrices = new Matrices();
	matrices.translate(0, 0, 0);
	for(i = 0; i < train.trainCars(); i++){
		render("ext", i);
		render("i", i);
        render("i_equipment", i);
        renderdetail("i_seat", i);
		render("front", i);
		renderdetail("equipment", i);
		matrices.pushPose();
		matrices.translate(0, 0, 0);
		render("bogie", i);
		matrices.translate(0, 0, 0);
		render("bogie", i);
		matrices.popPose();
		if(state.controlCarList[i]){
			matrices.pushPose();
			if((state.dirList[i] && !train.isReversed()) || (!state.dirList[i] && train.isReversed())){
				render("light1", i);
				render("light", i);
			}else{
				render("light", i);
				render("light1", i);
			}
			matrices.popPose();
		}
		var doorXN = train.doorLeftOpen[i] ? train.doorValue() * doorMoveValue : 0;
		var doorXP = train.doorRightOpen[i] ? train.doorValue() * doorMoveValue : 0;
		matrices.pushPose();
		matrices.translate(0, 0, doorXN);
		if(state.dirList[i]){
			render("doorRB", i);
			render("doorRB_i", i);
		}else{
			render("doorLF", i);
			render("doorLF_i", i);
		}
		matrices.translate(0, 0, 2 * -doorXN);
		if(state.dirList[i]){
			render("doorRF", i);
			render("doorRF_i", i);
		}else{
			render("doorLB", i);
			render("doorLB_i", i);
		}
		matrices.popPose();
		matrices.pushPose();
		matrices.translate(0, 0, -doorXP);
		if(state.dirList[i]){
			render("doorLF", i);
			render("doorLF_i", i);
		}else{
			render("doorRB", i);
			render("doorRB_i", i);
		}
		matrices.translate(0, 0, 2 * doorXP);
		if(state.dirList[i]){
			render("doorLB", i);
			render("doorLB_i", i);
		}else{
			render("doorRF", i);
			render("doorRF_i", i);
		}
		matrices.popPose();

        for (i = 0; i < train.trainCars() - 1; i++) { //gangway connection
            ctx.drawConnStretchTexture(idTexConnector, i);
          }

        //sounds
        for (i = 0; i < train.trainCars(); i++) { 
            if(train.isDoorOpening()){
                TrainScriptContext.playCarSound(idDoorOpeningSound, i, 0, 0, 0, 1, 1) //resource, cars, x, y, z, volume, pitch
            }
          }
	}
};
/* 終止処理 */
function disposeTrain(ctx, state, train){};

function smoothEnds(startValue, endValue, startTime, endTime, time) {
	if (time < startTime) return startValue;
	if (time > endTime) return endValue;
	var timeChange = endTime - startTime;
	var valueChange = (endValue - startValue) * (1 - Math.cos(Math.PI * (time - startTime) / timeChange)) / 2 + startValue;
	var value = -2*valueChange**3+3*valueChange**2;
	return value;
}